package rpg.arya;

import java.awt.*;
import javax.swing.*;

public class Creature {

	// character profile
	private String name;
	private String gender;
	private String description;

	// attributes
	private int life;
	private int lifePoints;
	private int speed;
	private int offense;
	private int defense;

	// combat judges
	private int chanceToHit;
	private int chanceToCounter;
	private int chanceToDefend;
	private int chanceToFlee;

	// combat variables
	private int damageSustained;	// how much pain absorbed
	private int damageInflicted;	// how much pain dealt
	private int combatInitiative;	// combat speed
	private boolean isFirst;		// flag for who goes first

	// boolean judges
	private boolean escaped;
	private boolean isDead;

	// equipment
	public Equipment weapon;
	public Equipment armor;

	// skills
	private String offensive;
	private String defensive;

	public Creature() {
		name = gender = description = "";
		life = lifePoints = speed = offense = defense = 0;
		chanceToHit = chanceToCounter = chanceToFlee = chanceToDefend = 0;
		damageSustained = damageInflicted = combatInitiative = 0;
		isFirst = false;

		weapon = new Equipment();
		armor = new Equipment();

		offensive = "";;
		defensive = "";

		escaped = false;
		isDead = false;
	}// ENDs constructor

	// setter methods
	public void setName(String name) {
		if (name != null)
			this.name = name;
		else
			this.name = "Ye who has no name.";
	}
	public void setGender(String gender) {
		if (gender != null)
			this.gender = gender;
		else
			this.gender = "crazy world";
	}
	public void setDescription(String description) {
		this.description = description;
	}

	public void setLife(int life) {
		this.life = life;
	}
	public void setLifePoints() {
		lifePoints = this.life * 100;
	}
	public void setSpeed(int speed) {
		this.speed = speed;
	}
	public void setOffense(int off) {
		this.offense = off;
	}
	public void setDefense(int def) {
		this.defense = def;
	}
	public void setChanceToHit(int cth) {
		this.chanceToHit = cth;
	}
	public void setChanceToDefend(int ctd) {
			this.chanceToDefend = ctd;
	}
	public void setChanceToCounter(int ctc) {
			this.chanceToCounter = ctc;
	}
	public void setChanceToFlee(int ctf) {
			this.chanceToFlee = ctf;
	}
	public void setDamageSustained(int ds) {
			this.damageSustained = ds;
	}
	public void setDamageInflicted(int di) {
			this.damageInflicted = di;
	}
	public void setCombatInitiative(int ci) {
			this.combatInitiative = ci;
	}
	public void setIsFirst(boolean first) {
			this.isFirst = first;
	}
	public void setOffensive(String off) {
		offensive = off;
	}
	public void setDefensive(String def) {
		defensive = def;
	}
	public void setEscaped(boolean b) {
			escaped = b;
	}
	// getter methods
	public String getName() {
		return name;
	}
	public String getGender() {
		return gender;
	}
	public String getDescription() {
		return description;
	}
	public int getLife() {
		return life;
	}
	public int getLifePoints() {
		return lifePoints;
	}
	public int getSpeed() {
		return speed;
	}
	public int getOffense() {
		return offense;
	}
	public int getDefense() {
		return defense;
	}
	public int getChanceToHit() {
		return chanceToHit;
	}
	public int getChanceToCounter() {
		return chanceToCounter;
	}
	public int getChanceToDefend() {
		return chanceToDefend;
	}
	public int getChanceToFlee() {
		return chanceToFlee;
	}
	public int getDamageSustained() {
		return damageSustained;
	}
	public int getDamageInflicted() {
		return damageInflicted;
	}
	public int getCombatInitiative() {
		return combatInitiative;
	}
	public boolean getIsFirst() {
		return isFirst;
	}
	public String getOffensive() {
		return offensive;
	}
	public String getDefensive() {
		return defensive;
	}

	public boolean getEscaped() {
		return escaped;
	}

	// misc methods
	public boolean isDead() {
		if (getLifePoints() <1)
			isDead = true;
		else
			isDead = false;

		return isDead;
	}

}// ENDs Creature


// inner classes
class Equipment {

	private String name;
	private String description;
	private String skill; // leave blank if none
	private int strength;

	public Equipment() {

		name = description = skill = "";
		strength = 0;
	}// END of constructor

	// setter methods
	public void setName (String name) {
		this.name = name;
	}
	public void setDescription (String desc) {
		description = desc;
	}
	public void setSkill (String skill) {
		this.skill= skill;
	}
	public void setStrength (int str) {
		strength=str;
	}

	// getter methods
	public String getName() {
		return name;
	}
	public String getDescription() {
		return description;
	}
	public String getSkill() {
		return skill;
	}
	public int getStrength() {
		return strength;
	}

}// END o' Equipment