package rpg.arya;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*; // file stuff
import java.util.*; // random number generator

public class GamePanel extends JPanel
					   implements KeyListener {

	// instance variables for gui game components
	private JTextField prompt;
	private JTextArea display;
	private JTextField topBar;

	// takes textField inputs as String value
	private String command;

	// shows all the keyboards keys being pressed in the console
	private String key;
	private boolean isEnter;

	// Defines player
	PlayerCharacter pc;
	int currentAttributePoints = 0;
	// SOON: Define NPC, Minion, MiniBoss, BigBoss, Monster, Mythical

	// game flow conditions
	boolean gameWon = false;
	boolean isPlaying = false;
	boolean isNewGame = false;
	boolean isGameLoaded = false;
	boolean isNewGameStarted = false;

	// random encounter variables
	int chanceForNpc = 0;
	int chanceForMonster = 0;
	int chanceForMythical = 0;

	boolean isMinionDefeated = false;
	boolean isMiniBossDefeated = false;
	boolean isBigBossDefeated = false;

	// random number generator initializers
	Random rand;
	int randNum;

	// Event handlers
	NewGameHandler newGameHandler;
	MainMenuHandler mainMenuHandler;
	GameHandler gameHandler;
	EncounterHandler encounterHandler;
	VisitHandler visitHandler;

	// NewGameHandler counter
	int count = -1;

	// non player characters; method to produce one when one is down
	private Npc currentNpc;

	public GamePanel() {

		// setup Game Panel attributes such as layout and color
		setLayout (new BorderLayout());
		setBackground(Color.red);

		newGameHandler = new NewGameHandler();
		mainMenuHandler = new MainMenuHandler();
		gameHandler = new GameHandler();
		encounterHandler = new EncounterHandler();
		visitHandler = new VisitHandler();

		// instantiate topBar label
		topBar = new JTextField(20);
		topBar.setBackground(Color.green);
		topBar.setEditable(false);

		// instantiate the gui input component
		JPanel commandPanel = new JPanel();
		JLabel label = new JLabel("command:");
		prompt = new JTextField(30);
		prompt.addKeyListener(this);
		prompt.setBackground(Color.white);
		//prompt.addActionListener(mainMenuHandler);

		// prompt to take user input
		commandPanel.setLayout(new FlowLayout());
		commandPanel.add(label);
		commandPanel.add(prompt);

		// disable ability to edit game information displayed
		display = new JTextArea();
		display.setEditable(false);
		display.setBackground(Color.orange);

		// add to GamePanel
		add(commandPanel,BorderLayout.SOUTH);
		add(new JScrollPane(display),BorderLayout.CENTER);
		add(topBar, BorderLayout.NORTH);

		// instantiates player
		pc = new PlayerCharacter();

		// instantiate current npc
		currentNpc = new Npc();

		// misc
		command = key = "";
		isEnter = false;

		// random number stuff
		rand = new Random();
		randNum = 0;

		// displays information at startup
		list();

		// switches control to take user input from main menu
		toMainMenu();
	}// END constructor

	public void keyTyped (KeyEvent e) {
		// overriding abstract method of KeyListener
	}
	public void keyReleased (KeyEvent e) {
		// overriding abstract methods of KeyListener
	}
	public void keyPressed (KeyEvent e) {
			// determine if the enter key was pressed
			key = e.getKeyText(e.getKeyCode());
			System.out.println(key);

			if (key.equals("Enter")) {
				isEnter = true;
				System.out.println("\nisEnter! " + randomNumber());
			}
	}// END of keyPressed


	// random number generator method
	public int randomNumber() {
		// 101 causes numbers to be generated from 0-100
		randNum = rand.nextInt(101);
		return randNum;
	}// END of randomNumber()


	public void clrscr() {
		// clears text area display
		display.setText("");
	}

	public void clrPrompt() {

		// clears text field for prompt
		prompt.setText("");
	}


	// method to generate an npc for encounter
	public void getNpc() {
		currentNpc.generateStats();
	}

// ! MAIN GAME METHOD
	public void playGame() {

		// when the game is played,
		// there is ALWAYS an encounter!

		toEncounter();
		// random encounter variables
		chanceForNpc = randomNumber();
		chanceForMonster = randomNumber();
		chanceForMythical = randomNumber();

		currentNpc.setChanceToFlee(randomNumber());

/*

		if (currentNpc.getChanceToFlee()>0
			&& randomNumber()<currentNpc.getChanceToFlee())
			currentNpc.setEscaped(true);
		else
			currentNpc.setEscaped(false);
*/

		if (pc.getIsEncounterOver() != true) {

			// do battle still
		//	show npc: name, gender, description
			display.append("\nA " + currentNpc.getGender()
							+ ", " + currentNpc.getName()
							+ ",\n" + currentNpc.getDescription());

			// conditions for ending an encounter
			// pc is dead
			// npc is dead
			// pc flees
			// npc flees
			// pc talks to good npc
/*			if ( pc.isDead()) {
				// actually display game over, switch to main menu
				// reset values of encounters, perhaps?
				pc.setIsEncounterOver(true);
				display.append("\nYou were killed. Game Over.");
				list();
				toMain();
			}
			else if (currentNpc.isDead()) {
				pc.setIsEncounterOver(true);
				display.append("\n"+currentNpc.getName() + " died by your hands.!");
*/		//	} // npc dead
			if (currentNpc.getEscaped()) {
				pc.setIsEncounterOver(true);
				display.append("\n"+currentNpc.getName() + " ran away!");
			}
			else if (pc.getEscaped()) {
				pc.setIsEncounterOver(true);
			}
			else
				pc.setIsEncounterOver(false);
		}
		else {

		if (pc.getMiniBossesDefeated() < 4) {

			if (pc.getMinionsDefeated() < 4) {

				if (chanceForNpc>0 && chanceForNpc<=pc.getChanceForNpc()) {
					//encounterNpc
					display.append("\nOn the road ahead, you see something.");
					getNpc();
					pc.setBattlesFought(pc.getBattlesFought()+1);
					pc.setIsEncounterOver(false);
				}
				/*else if (1<=chanceForMonster && chanceForMonster<=pc.getChanceForMonster()) {
					//encounterMonster
					display.append("\nEncountered a Monster\n");
					pc.setBattlesFought(pc.getBattlesFought()+1);
				}*/
				else if (1<=chanceForMythical && chanceForMythical<=pc.getChanceForMythical()) {
					//encounterMythical
					display.append("\nEncountered a Mythical Beast\n");
					pc.setBattlesFought(pc.getBattlesFought()+1);
				}
				else {
					// fight minion
					display.append("\nFought Minion\n");
					pc.setBattlesFought(pc.getBattlesFought()+1);
					// test stuff
					if (randomNumber() < 50)
						isMinionDefeated = true;
					else
						isMinionDefeated = false;

					if (isMinionDefeated) {
					// increment minionsDefeated
						pc.setMinionsDefeated(pc.getMinionsDefeated()+1);
						display.append("\nDefeated Minion.\n");
					}
					else {
						display.append("\nLost to Minion.\n");
					}
				}
			}// Minions
			else {
				// fight miniBoss;
				display.append("\nFighting MiniBoss\n");
				pc.setBattlesFought(pc.getBattlesFought()+1);
				if (randomNumber() > 50)
					isMiniBossDefeated = true;
				else
					isMiniBossDefeated = false;

				if (isMiniBossDefeated) {
					//increment miniBossedDefeated
					pc.setMiniBossesDefeated(pc.getMiniBossesDefeated()+1);
					pc.setMinionsDefeated(0);
					display.append("\nDefeated MiniBoss\n");
				}
				else {
					display.append("\nLost to MiniBoss\n");
				}
			}
		}// MiniBoss
		else {
			//fight big boss
			if (randomNumber() < 50)
				isBigBossDefeated = true;
			else
				isBigBossDefeated = false;

			pc.setBattlesFought(pc.getBattlesFought()+1);

			if (isBigBossDefeated) {
				// assuming you lived and big boss didnt,
				// display victory screen
				gameWon=true;
				display.append("\nYou defeated the Big Boss\n");
			}
			else {
				// assuming you died, display game over screen
				display.append("\nYou lost to the Big Boss. Game Over\n");
			}
		}// BigBoss
	}// big if..else

		if (pc.getIsEncounterOver()) {
			toGame();
		}
		else {
			toEncounter();
		}
	}// END of playGame();


	public boolean loadGame() {
		/* extract game information from datafile.
			- player character data
		*/
		display.setText("");
		display.append("Game loaded.\n\n");

		return true;
	}// ENDs loadGame()

	public void saveGame() {
		// this method writes all pertinent game data to a text file
		try {
    	    BufferedWriter out = new BufferedWriter(new FileWriter("arya.data"));
    	    out.write(pc.getName());
			out.write("\n"+pc.getGender());
			out.write("\n"+pc.getLife());
			out.write("\n"+pc.getLifePoints());
			out.write("\n"+pc.getSpeed());
			out.write("\n"+pc.getOffense());
			out.write("\n"+pc.getDefense());
			out.write("\n"+pc.weapon.getName());
			out.write("\n"+pc.weapon.getDescription());
			out.write("\n"+pc.weapon.getStrength());
			out.write("\n"+pc.weapon.getSkill());
			out.write("\n"+pc.armor.getName());
			out.write("\n"+pc.armor.getDescription());
			out.write("\n"+pc.armor.getStrength());
			out.write("\n"+pc.armor.getSkill());
			out.write("\n"+pc.getOffensive());
			out.write("\n"+pc.getDefensive());

			out.write("\n"+pc.getMinionsDefeated());
			out.write("\n"+pc.getMiniBossesDefeated());
			out.write("\n"+pc.getBattlesFought());
			out.close();
	   	} catch (IOException e) {
    		System.err.println("\nData file not closed properly.");
    	}

		display.append("\nGame saved\n");
	}// ENDS saveGame()

	// general commands
	public void list() {

		display.setText("");
		display.append("AVAILABLE GAME COMMANDS"
						+"\n------------------------------------------------------------------------"
						+ "\nnew ~ creates a new character."
						+ "\nload ~ resumes playing a saved game."
						+ "\nsave ~ stores game information."
						+ "\nplay ~ starts the game.\n"
						+ "\nattack ~ during game play, attacks opponent."
						+ "\ntalk ~ during game, speaks with creature."
						+ "\nflee ~ during game, attempts to run away."
						+ "\nspecial ~ during game, calls upon special powers."
						+ "\nrecombine ~ during game, recombines dna of mythical beast"
						+ "\n                     with your own, giving you innate powers.\n"
						+ "\nstatus ~ shows ALL of your character's information"
						+ "\nequip ~ gets and wields weapon or wears armor."
						+ "\ndiscard ~ ultimately removes weapon or armor from possession.\n"
						+ "\nlist ~ shows you a list of all the available commands."
						+ "\nexit ~ closes the application."
						+ "\n-----------------------------------------------------------------------\n");
	}// END list


	public void attack() {
	}
	public void talk() {
		// attempts to engage in conversation with creature
		// if discussion was a successful parlay, fame is adjusted
	}
	public void flee() {
		// escapes from one encounter to another
	}
	public void special() {
		// use the special skill obtained from recombining gene with myth
	}
	public void status() {
		// displays pertinent character information to the screen
	}

	public void visit() {
		// make a stop to the geneticist/scholar Aliyah'Sha
		// here you will be allowed to combine any special genes
		// you've obtained during travels with any of your own
	}

	public void toNewGame() {
		prompt.removeActionListener(mainMenuHandler);
		prompt.addActionListener(newGameHandler);
		// display message informing about transition to create a new char
		topBar.setText("");
		topBar.setText("CREATING CHARACTER");
		display.setText("");
		display.append("Press ENTER to begin creating your new character.\n");
	}// toNewGame

	public void toMainMenu() {
		prompt.removeActionListener(gameHandler);
		prompt.removeActionListener(newGameHandler);
		prompt.removeActionListener(encounterHandler);
		prompt.removeActionListener(visitHandler);
		prompt.addActionListener(mainMenuHandler);
		// display a message indicating where you are at now
		topBar.setText("");
		topBar.setText("MAIN MENU:     new | play | list | exit");
		display.append("\nYou are now at the MAIN Menu.");
	}// toMainMenu

	public void toGame() {
		prompt.removeActionListener(encounterHandler);
		prompt.removeActionListener(mainMenuHandler);
		prompt.removeActionListener(newGameHandler);

		prompt.removeActionListener(visitHandler);
		prompt.addActionListener(gameHandler);
		topBar.setText("");
		topBar.setText("PLAYING:     camp | go | visit | status | save | list | exit");
	}// END of toGame

	public void toEncounter() {
		prompt.removeActionListener(gameHandler);
		prompt.removeActionListener(mainMenuHandler);
		prompt.removeActionListener(newGameHandler);
		prompt.removeActionListener(visitHandler);
		prompt.addActionListener(encounterHandler);
		topBar.setText("");
		topBar.setText("ENCOUNTER:     look | attack | talk | flee | special | status | save | list | exit");
	}// END of toEncounter

	public void toVisit() {

		prompt.removeActionListener(gameHandler);
		prompt.addActionListener(visitHandler);
		topBar.setText("");
		topBar.setText("VISITING ALIYAAH'SHA:     recombine [] [] | save | list | exit");
	}

private class NewGameHandler implements ActionListener {
	public void actionPerformed(ActionEvent e) {

		count++;
		// recieves user commands typed in textfield
		command = (e.getActionCommand().toLowerCase());
		int temp = 0;

		if (command.equals("exit")) {
			display.append("\n\nLeaving character creation area."
							+"\nReturning to Main Menu.");
			// reset value of count
			count = -1;
			toMainMenu();
		}
		else {
			if (count == 0) {
				display.append("\nEnter Name: ");
			}

			if (count == 1) {
				pc.setName(command);
				clrPrompt();
				display.append(pc.getName());
				display.append("\nEnter Gender (f/m): ");
			}

			if (count == 2) {
				if (command.equals("f"))
					pc.setGender("female");
				else if (command.equals("m"))
		    		pc.setGender("male");
		    	else
		    		pc.setGender("female");
		    	clrPrompt();
		    	display.append(pc.getGender());
		    	display.append("\n\n22 points left to distribute."
		    				  +"\nenter life: ");
			}

			if (count == 3) {
				currentAttributePoints = Integer.parseInt(command);
				if (currentAttributePoints > 10) {
					pc.setLife(10);
					currentAttributePoints = 10;
				}
				else if (currentAttributePoints < 1) {
					pc.setLife(1);
					currentAttributePoints = 1;
				}
				else
					pc.setLife(Integer.parseInt(command));

				System.out.println("\nLife 1= "+ Integer.parseInt(command));
				System.out.println("\nLife 2= "+ pc.getLife());
				pc.setLifePoints();
				clrPrompt();
				display.append(pc.getLife() + " x 100 = " + pc.getLifePoints()
				               + " life points");
				display.append("\n\n"+(22-currentAttributePoints)
							 + "points left to distribute.");
				display.append("\nenter speed: ");
			}

			if (count == 4) {
				currentAttributePoints += Integer.parseInt(command);
				if ((Integer.parseInt(command) > 10) ||
					(currentAttributePoints > 22)) {
					temp = ( (22-pc.getLife() )/3 );
					pc.setSpeed(temp);
					currentAttributePoints = pc.getLife() + pc.getSpeed();
				}
				else if (currentAttributePoints < 1) {
					temp = (22/4);
					pc.setSpeed(temp);
					currentAttributePoints = temp * 2;
				}
				else
					pc.setSpeed(Integer.parseInt(command));

				clrPrompt();
				display.append(pc.getSpeed() +
								"\n\n" + (22-currentAttributePoints) +
								" points left to distribute.");
				display.append("\nenter offense: ");
			}

			if (count == 5) {
				currentAttributePoints += Integer.parseInt(command);
				if ((Integer.parseInt(command) > 10) ||
					(currentAttributePoints > 22)) {
					temp = ( (22-(pc.getLife()+pc.getSpeed()))/2 );
					pc.setOffense(temp);
					currentAttributePoints = pc.getLife() + pc.getSpeed()
											+ pc.getOffense();
				}
				else if (currentAttributePoints < 1) {
					temp = (22/4);
					pc.setOffense(temp);
					currentAttributePoints = temp * 3;
				}
				else
					pc.setOffense(Integer.parseInt(command));

				clrPrompt();
				display.append(pc.getOffense() +
								"\n\n" + (22-currentAttributePoints) +
								" points left to distribute.");
				display.append("\nenter defense: ");
			}
			if (count == 6) {
				currentAttributePoints += Integer.parseInt(command);
				if ((Integer.parseInt(command) > 10) ||
					(currentAttributePoints > 22)) {
					temp = (22- (pc.getLife() + pc.getSpeed() + pc.getOffense() ));
					if (temp > 10)
						temp = 10;
					else if (temp < 1)
						temp =1;
					pc.setDefense(temp);
					currentAttributePoints = pc.getLife() + pc.getSpeed() +
											pc.getOffense() + pc.getDefense();
				}
				else if (currentAttributePoints < 1) {
					temp = (22/4);
					pc.setDefense(temp);
					currentAttributePoints = temp * 4;
				}
				else
					pc.setDefense(Integer.parseInt(command));

				clrPrompt();
				display.append(pc.getDefense() +
								"\n\n" + (22-currentAttributePoints) +
								" points left to distribute.");
				display.append("\n\nchoose weapon by number: "
								+"\n [1] Dark Blade"
								+"\n [2] Bobo Blaster"
								+"\n [3] Skull Crusher"
								+"\n [4] Demon Whistler");

			}
			if (count == 7) {
				if (command.equals("1"))
					pc.weapon.setName("Dark Blade");

				else if (command.equals("2"))
					pc.weapon.setName("Bobo Blaster");

				else if (command.equals("3"))
					pc.weapon.setName("Skull Crusher");

				else if (command.equals("4"))
					pc.weapon.setName("Demon Whistler");
				else
					pc.weapon.setName("Dark Blade");

				clrPrompt();
				display.append("\nYou chose the "+pc.weapon.getName());
				display.append("\n\nchoose armor from number below: "
							  +"\n [1] Turbo Suit"
							  +"\n [2] Powered Armor"
							  +"\n [3] Knights Armor"
							  +"\n [4] Nice Clothes");

			}
			if (count == 8) {
				if (command.equals("1"))
					pc.armor.setName("Turbo Suit");

				else if (command.equals("2"))
					pc.armor.setName("Powered Armor");

				else if (command.equals("3"))
					pc.armor.setName("Knights Armor");

				else if (command.equals("4"))
					pc.armor.setName("Nice Clothes");
				else
					pc.armor.setName("Nice Clothes");

				clrPrompt();
				display.append("\nYou chose to wear "+pc.armor.getName());
				display.append("\n\npick an offensive skill by number: "
								  +"\n [1] BackStab"
								  +"\n [2] Subdue"
								  +"\n [3] Throw"
								  +"\n [4] CounterStrike");
			}

			if (count == 9) {
				if (command.equals("1"))
					pc.setOffensive("BackStab");
				else if (command.equals("2"))
					pc.setOffensive("Subdue");
				else if (command.equals("3"))
					pc.setOffensive("Throw");
				else if (command.equals("4"))
					pc.setOffensive("CounterStrike");
				else
					pc.setOffensive("Throw");

				clrPrompt();
				display.append("\nYou are capable of "+pc.getOffensive());
				display.append("\n\npick a defensive skill by number: "
							+"\n [1] Dodge"
							+"\n [2] Parry"
							+"\n [3] Block"
							+"\n [4] Circle");
			}

			if (count == 10) {

				if (command.equals("1"))
					pc.setDefensive("Dodge");
				else if (command.equals("2"))
					pc.setDefensive("Parry");
				else if (command.equals("3"))
					pc.setDefensive("Block");
				else if (command.equals("4"))
					pc.setDefensive("Circle");
				else
					pc.setDefensive("Dodge");

				clrPrompt();
				display.append("\nYou are capable of "+pc.getDefensive());
				display.append("\n\nAre you done? (y/n) ");
			}

			if (count == 11) {
				if (command.equals("y")) {
					display.append("\n\nCharacter successfully created.\n\n");
					toGame();
					clrPrompt();
					// restarts the character creation sequence
					count = -1;
				}
				else if (command.equals("n")) {
					// resets all values necessary to go thru this loop
					count=-1;
					currentAttributePoints=0;

					display.append("\nRestarting. Press ENTER to continue..\n\n");
				}
				else {
					display.append("\nInvalid response, answer y/n.\n");
					count = 10;
				}
			}
		}// else..if (exit)
	}// End of ActionPerformed
}// END of NewGameHander


private class MainMenuHandler implements ActionListener {
	public void actionPerformed (ActionEvent e) {
		// recieves user commands typed in textfield
		//command = (prompt.getText().toLowerCase());
		command = (e.getActionCommand().toLowerCase());
		// general - application wide commands
		if (command.equals("list")) {
			list();
		}
		if (command.equals("exit")) {
			// indicate that the application will be ending now
			display.append("\n\nEXITING GAME...");
			System.out.println("Closing Application...");
			System.exit(0);
		}

		if (command.equals("new")) {
			toNewGame();
			prompt.setText("");
		}
		if (command.equals("play")) {
			if (loadGame()) {
				toGame();
				playGame();
			}
			else {
				// indicate going to create a new game because
				// there were no previously saved games to continue
				toNewGame();
			}
		}// end if (isPlaying)..else


	}// END actionPerformed
}// End of MainMenuHandler

private class GameHandler implements ActionListener {
	public void actionPerformed (ActionEvent e) {
		// recieves user commands typed in textfield
		//command = (prompt.getText().toLowerCase());
		command = (e.getActionCommand().toLowerCase());
		// administrative commands
		if (command.equals("exit")) {
			// exit out of current game to main menu
			saveGame();
			toMainMenu();
			command = "";
		}
		if (command.equals("list")) {
			list();
		}
		if (command.equals("save")) {
			saveGame();
		}

		// commands to use during game
		if (command.equals("visit")) {
			//visit();
			toVisit();
		}
		if (command.equals("camp")) {
			display.append("\n\nYou make camp in a secured hiding place.");
			display.append("\nYou heal fully after resting undisturbed.");
			display.append("\nLife Points (before) : " +
							pc.getLifePoints()
							+ "\nLife Points (after) : ");
			pc.setLifePoints();
			display.append(pc.getLifePoints()+"\n");
		}

		// only want to encounter creatures when player goes on the road
		if (command.equals("go")) {
			playGame();
		}

	}// END actionPerformed
}// End of GameHandler

private class EncounterHandler implements ActionListener {
	public void actionPerformed (ActionEvent e) {
		// recieves user commands typed in textfield
		//command = (prompt.getText().toLowerCase());
		command = (e.getActionCommand().toLowerCase());

		// administrative commands
		if (command.equals("exit")) {
			// exit out of current game to main menu
			saveGame();
			toMainMenu();
			command = "";
		}
		if (command.equals("list")) {
			list();
		}
		if (command.equals("save")) {
			saveGame();
		}

		// commands to use during encounters
		if (command.equals("attack")) {
			//attack();
			display.append("\nslash slash");
		}
		if (command.equals("talk")) {
			//talk();
			display.append("\nblah blah");
		}
		if (command.equals("flee")) {
			//flee();
			display.append("\neeek eeeek!");
			pc.setChanceToFlee(randomNumber());
			if (pc.getChanceToFlee()>0
				&& randomNumber()<pc.getChanceToFlee()) {
				pc.setEscaped(true);
				display.append("\nYou ran away!");
				pc.setIsEncounterOver(true);
				toGame();
			}
			else {
				pc.setEscaped(false);
				display.append("\nYou couldn't escape!");
				pc.setIsEncounterOver(false);
				toEncounter();
			}
		}
		if (command.equals("special")) {
			//special();
			display.append("\noooo oooo");
		}
		if (command.equals("status")) {
			status();
			display.append("\nhrmm hrmm");
		}
		if (command.equals("look")) {
			display.append(pc.look(currentNpc));
		}

		//clrPrompt();


	}// END actionPerformed
}// End of EncounterHandler


private class VisitHandler implements ActionListener {
	public void actionPerformed (ActionEvent e) {
		// recieves user commands typed in textfield
		//command = (prompt.getText().toLowerCase());

		command = (e.getActionCommand().toLowerCase());

		// administrative commands
		if (command.equals("exit")) {
			// exit out of current game to main menu
			saveGame();
			toMainMenu();
			command = "";
		}
		if (command.equals("list")) {
			list();
		}
		if (command.equals("save")) {
			saveGame();
		}


	}// END actionPerformed
}// End of visitHandler


}// END GamePanel
