package rpg.arya;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class HelpPanel extends JPanel {

	// instance variables
	private JTabbedPane tabbedPane;
	int index[] = new int[6];
	boolean enabled[] = new boolean[6];

	private JPanel generalHelpPanel;
	private JPanel combatHelpPanel;

	// instance constants
	private final int GENERALHELP = 0;
	private final int COMBATHELP = 1;

	public HelpPanel() {

		setLayout (new BorderLayout());
		setBackground(Color.white);

		tabbedPane = new JTabbedPane();
		// Calls method to set color
		tabbedPane.setBackground(Color.white);
		tabbedPane.setForeground(Color.magenta);

		buildGeneralHelpPanel();
		buildCombatHelpPanel();

		// a method that adds individual tabs to tabbedpane objects.
		populateTabbedPane();

		add(tabbedPane, BorderLayout.CENTER);

	}// END constructor

	private void populateTabbedPane() {

    	// Create tabs with titles

 		tabbedPane.addTab(
			"general",
			null,
			generalHelpPanel,
       		"Click here for help.");
		index[GENERALHELP] = tabbedPane.getTabCount()-1;
    	enabled[GENERALHELP] = tabbedPane.isEnabledAt(index[GENERALHELP]);
    	tabbedPane.setEnabledAt(index[GENERALHELP], true);

		tabbedPane.addTab(
			"combat",
		    null,
		    combatHelpPanel,
       		"Click here for information on the developer.");
		index[COMBATHELP] = tabbedPane.getTabCount()-1;
    	enabled[COMBATHELP] = tabbedPane.isEnabledAt(index[COMBATHELP]);
    	tabbedPane.setEnabledAt(index[COMBATHELP], true);

    } //Ends populateTabbedPane method

	private void buildGeneralHelpPanel() {
		generalHelpPanel = new JPanel();
		generalHelpPanel.setBackground(Color.black);
	}// END

	private void buildCombatHelpPanel() {
		combatHelpPanel = new JPanel();
		combatHelpPanel.setBackground(Color.pink);
	}// END

}// END HelpPanel