package rpg.arya;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

public class MyRpg extends JFrame {

	// instance constants
	private final int TITLEPANEL=0;
	private final int GAMEPANEL=1;
	private final int HELPPANEL=2;
	private final int ABOUTPANEL=3;

	// ContentPane
	Container contentPane;

	private JTabbedPane tabbedPane;

	int index[] = new int[6];
	boolean enabled[] = new boolean[6];

	public MyRpg() {

		super("Arya, Dark Junto!");

		contentPane = getContentPane();

		addWindowListener(new WindowAdapter() {
			public void windowClosing (WindowEvent e) {
				System.exit(0);
			}
		});

		// Tabbed pane with panels for JComponents
		// Instantiate JTabbedPane with keyword new
		tabbedPane = new JTabbedPane(SwingConstants.TOP);
		// Calls method to set color
		tabbedPane.setBackground(Color.white);
		tabbedPane.setForeground(Color.blue);

		// a method that adds individual tabs to tabbedpane objects.
		populateTabbedPane();

		contentPane.add(tabbedPane,BorderLayout.CENTER);

		addComponentListener(new ComponentAdapter() {
			public void componentResized(ComponentEvent e) {
			// whatever you want to do goes here. e.g.:
				//System.out.println("Window resized");
				contentPane.setSize(453,450);
			}
		});

   		pack();
	}// constructor

	private void populateTabbedPane() {

    	// Create tabs with titles
		tabbedPane.addTab(
			"title",
			null,
			new TitleScreenPanel(),
			"Click here to view the main menu.");
		index[TITLEPANEL] = tabbedPane.getTabCount()-1;
    	enabled[TITLEPANEL] = tabbedPane.isEnabledAt(index[TITLEPANEL]);
    	tabbedPane.setEnabledAt(index[TITLEPANEL], true);

	   	tabbedPane.addTab(
			"game",
		    null,
		    new GamePanel(),
          	"Click here to play the game.");
		index[GAMEPANEL] = tabbedPane.getTabCount()-1;
    	enabled[GAMEPANEL] = tabbedPane.isEnabledAt(index[GAMEPANEL]);
    	tabbedPane.setEnabledAt(index[GAMEPANEL], true);

 		tabbedPane.addTab(
			"help",
			null,
			new HelpPanel(),
       		"Click here for help.");
		index[HELPPANEL] = tabbedPane.getTabCount()-1;
    	enabled[HELPPANEL] = tabbedPane.isEnabledAt(index[HELPPANEL]);
    	tabbedPane.setEnabledAt(index[HELPPANEL], true);

		tabbedPane.addTab(
			"about",
		    null,
		    new AboutPanel(),
       		"Click here for information on the developer.");
		index[ABOUTPANEL] = tabbedPane.getTabCount()-1;
    	enabled[ABOUTPANEL] = tabbedPane.isEnabledAt(index[ABOUTPANEL]);
    	tabbedPane.setEnabledAt(index[ABOUTPANEL], true);

		// Register a change listener
    	tabbedPane.addChangeListener(new ChangeListener() {
       		// This method is called whenever the selected tab changes
        	public void stateChanged(ChangeEvent evt) {
       			JTabbedPane pane = (JTabbedPane)evt.getSource();

       			// Get current tab
       			int paneSelected = pane.getSelectedIndex();
       			System.out.println("Pane Selected: " + paneSelected);

       			//if (paneSelected == NEWGAME) {

					// tabbedPane.setEnabledAt(index[TITLE], false);
				//}
       		}
    	});


    } //Ends populateTabbedPane method


	public static void main (String args[]) {

		MyRpg game = new MyRpg();

		// defines frame window
		game.setSize(453,450);
		game.setBackground(Color.white);
		game.setVisible(true);
		game.setResizable(false);
	}// main

}// MyRpg