package rpg.arya;

import java.awt.*;
import javax.swing.*;

public class PlayerCharacter extends Creature {

	// fame
	private int fame;

	// combat statistics
	private int battlesFought;
	private int battlesWon;
	private int battlesLost;
	private int battlesDrawn;
	private int battlesFled;

	// random encounters
	private int chanceForNpc;
	private int chanceForMonster;
	private int chanceForMythical;
	private final int CHANCE_NPC = 33;
	private final int CHANCE_MONSTER = 33;
	private final int CHANCE_MYTHICAL = 15;
	private boolean isEncounterOver;

	// objective statistics; game flow values
	private int minionsDefeated;
	private int miniBossesDefeated;
	private boolean isBigBossDefeated;

	// genes w/ location
	private final int LIFE = 0;  // primary elemental type
	private final int SPEED = 1;
	private final int OFFENSE = 2;
	private final int DEFENSE = 3;
	String genes[]; // invokes skills
	// genes[LIFE]= EARTH;

	public PlayerCharacter() {

		battlesFought = battlesWon = battlesLost = battlesDrawn = battlesFled = 0;
		chanceForNpc = CHANCE_NPC;
		chanceForMonster = CHANCE_MONSTER;
		chanceForMythical = CHANCE_MYTHICAL;

		minionsDefeated = miniBossesDefeated = 0;
		isBigBossDefeated = false;
		fame = 0;
		genes = new String[4];
		isEncounterOver = true;
	}// END of constructor

	// setters methods
	public void setFame(int fame) {
		this.fame = fame;
	}
	public void setBattlesFought(int bf) {
		battlesFought = bf;
	}
	public void setBattlesWon(int bw) {
		battlesWon = bw;
	}
	public void setBattlesLost(int bl) {
		battlesLost = bl;
	}
	public void setBattlesFled(int fled) {
		battlesFled = fled;
	}
	public void setBattlesDrawn(int bd) {
		battlesDrawn = bd;
	}
	public void setChanceForNpc(int cnpc) {
		chanceForNpc = cnpc;
	}
	public void setChanceForMonster(int cmon) {
		chanceForMonster = cmon;
	}
	public void setChanceForMythical(int cmyth) {
		chanceForMythical = cmyth;
	}
	public void setMinionsDefeated(int md) {
		minionsDefeated = md;
	}
	public void setMiniBossesDefeated(int mbd) {
		miniBossesDefeated = mbd;
	}
	public void setIsBigBossDefeated(boolean victoryFlag) {
		isBigBossDefeated = victoryFlag;
	}
	public void setGene(String gene, int location) {

		genes[location] = gene;  // or skill
	}
	public void setIsEncounterOver(boolean v) {
			isEncounterOver = v;
	}


	// getter methods
	public int getFame() {
		return fame;
	}
	public int getBattlesWon() {
		return battlesWon;
	}
	public int getBattlesFought() {
		return battlesFought;
	}
	public int getBattlesLost() {
		return battlesLost;
	}
	public int getBattlesFled() {
		return battlesFled;
	}
	public int getBattlesDrawn() {
		return battlesDrawn;
	}
	public int getChanceForNpc() {
		return chanceForNpc;
	}
	public int getChanceForMonster() {
		return chanceForMonster;
	}
	public int getChanceForMythical() {
		return chanceForMythical;
	}
	public int getMinionsDefeated() {
		return minionsDefeated;
	}
	public int getMiniBossesDefeated() {
		return miniBossesDefeated;
	}
	public boolean getIsBigBossDefeated() {
		return isBigBossDefeated;
	}
	public String getGene(int location) {
		return genes[location];
	}
	public boolean getIsEncounterOver() {
			return isEncounterOver;
	}

	// misc commands
	public String look (Npc npc) {
		return ("\nA " + npc.getGender() + ", " + npc.getName() + ",\n" +
			  npc.getDescription());
	}// END of look

}// END of PlayerCharacter